E_MODEL_HEXAGON_PLATFORM = smlua_model_util_get_id("hexagon_platform")
COL_HEXAGON_PLATFORM = smlua_collision_util_get("hexagon_platform_collision")

function bhv_hex_platform_init(obj)
    obj_set_model_extended(obj, E_MODEL_HEXAGON_PLATFORM)
    obj.collisionData = COL_HEXAGON_PLATFORM
end

function bhv_spin_platform_init(obj)
    obj_set_model_extended(obj, E_MODEL_HEXAGON_PLATFORM)
    obj.collisionData = COL_HEXAGON_PLATFORM
end

--This hack has Star Replicas too, wow!

function get_star_count()
    local courseMax = 25
    local courseMin = 1
    return save_file_get_total_star_count(get_current_save_file_num() - 1, courseMin - 1, courseMax - 1)
end

function despawn_if_stars_below_count(obj, count)
    if get_star_count() < count then
        obj_mark_for_deletion(obj)
    end
end

function bhv_star_replica_init(obj)
    despawn_if_stars_below_count(obj, 54) -- 54 star check
end

hook_behavior(id_bhvSslMovingPyramidWall, OBJ_LIST_SURFACE, false, bhv_hex_platform_init, nil)
hook_behavior(id_bhvMerryGoRound, OBJ_LIST_SURFACE, false, bhv_spin_platform_init, nil)

